/*
 * This file is generated by jOOQ.
 */
package nu.studer.sample.tables;


import javax.annotation.processing.Generated;

import nu.studer.sample.Keys;
import nu.studer.sample.Selfbooster;
import nu.studer.sample.tables.records.PurposeCategoriesRecord;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row2;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.15.1"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class PurposeCategories extends TableImpl<PurposeCategoriesRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>selfbooster.purpose_categories</code>
     */
    public static final PurposeCategories PURPOSE_CATEGORIES = new PurposeCategories();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<PurposeCategoriesRecord> getRecordType() {
        return PurposeCategoriesRecord.class;
    }

    /**
     * The column <code>selfbooster.purpose_categories.uuid</code>.
     */
    public final TableField<PurposeCategoriesRecord, java.util.UUID> UUID = createField(DSL.name("uuid"), SQLDataType.UUID.nullable(false).defaultValue(DSL.field("uuid_generate_v4()", SQLDataType.UUID)), this, "");

    /**
     * The column <code>selfbooster.purpose_categories.category_name</code>.
     */
    public final TableField<PurposeCategoriesRecord, String> CATEGORY_NAME = createField(DSL.name("category_name"), SQLDataType.VARCHAR(100), this, "");

    private PurposeCategories(Name alias, Table<PurposeCategoriesRecord> aliased) {
        this(alias, aliased, null);
    }

    private PurposeCategories(Name alias, Table<PurposeCategoriesRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>selfbooster.purpose_categories</code> table
     * reference
     */
    public PurposeCategories(String alias) {
        this(DSL.name(alias), PURPOSE_CATEGORIES);
    }

    /**
     * Create an aliased <code>selfbooster.purpose_categories</code> table
     * reference
     */
    public PurposeCategories(Name alias) {
        this(alias, PURPOSE_CATEGORIES);
    }

    /**
     * Create a <code>selfbooster.purpose_categories</code> table reference
     */
    public PurposeCategories() {
        this(DSL.name("purpose_categories"), null);
    }

    public <O extends Record> PurposeCategories(Table<O> child, ForeignKey<O, PurposeCategoriesRecord> key) {
        super(child, key, PURPOSE_CATEGORIES);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Selfbooster.SELFBOOSTER;
    }

    @Override
    public UniqueKey<PurposeCategoriesRecord> getPrimaryKey() {
        return Keys.PK_PURPOSE_CATEGORIES_ID;
    }

    @Override
    public PurposeCategories as(String alias) {
        return new PurposeCategories(DSL.name(alias), this);
    }

    @Override
    public PurposeCategories as(Name alias) {
        return new PurposeCategories(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public PurposeCategories rename(String name) {
        return new PurposeCategories(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public PurposeCategories rename(Name name) {
        return new PurposeCategories(name, null);
    }

    // -------------------------------------------------------------------------
    // Row2 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row2<java.util.UUID, String> fieldsRow() {
        return (Row2) super.fieldsRow();
    }
}
